package services.as400Connector.server;

import javax.resource.ResourceException;
import javax.resource.spi.LocalTransaction;

import libraries.ejbUtils.logging.Logger;

public class AS400LocalTransaction implements LocalTransaction {

  private AS400ManagedConnection managedCx;
  private Logger log;
  
  public AS400LocalTransaction(AS400ManagedConnection managedCx) {
    this.managedCx = managedCx;
    this.log       = managedCx.getLogger();
  }

  public void begin() throws ResourceException {
    log.info("Going to begin new local transaction");
    managedCx.setInTransaction(true);
  }

  public void commit() throws ResourceException {
    log.info("going to commit local transaction");
    managedCx.commitTransaction();
  }

  public void rollback() throws ResourceException {
    log.info("Going to rollback new local transaction");
    managedCx.rollbackTransaction();
  }

}
