package services.as400Connector.server;

import javax.resource.ResourceException;
import javax.resource.spi.ManagedConnectionMetaData;

public class AS400ManagedConnectionMetaData implements ManagedConnectionMetaData {

  private AS400ManagedConnection managedCx;
  
  public AS400ManagedConnectionMetaData(AS400ManagedConnection managedCx) {
    this.managedCx = managedCx;
  }

  public String getEISProductName() throws ResourceException {
    return "AS400 - " + managedCx.getAS400System().getSystemName();
  }

  public String getEISProductVersion() throws ResourceException {
    try {
      return "V" + Integer.toString(managedCx.getAS400System().getVersion()) + "R" + Integer.toString(managedCx.getAS400System().getRelease()) + "M" + Integer.toString(managedCx.getAS400System().getModification());
    } catch (Exception e) {
      throw new RuntimeException("Could not retrieve product version",e);
    }
  }

  public int getMaxConnections() throws ResourceException {
    return Integer.MAX_VALUE;
  }

  public String getUserName() throws ResourceException {
    return managedCx.getAS400System().getUserId();
  }
  
}
