package libraries.ejbUtils.client;

import java.util.HashMap;
import java.util.Map;
import java.util.Properties;

import javax.naming.InitialContext;
import javax.naming.NamingException;

public class RemoteClientService {

  private static Map<Endpoint, InitialContext> contexts = new HashMap<Endpoint, InitialContext>();
  
  public synchronized static Object getRemoteInterface(String host, int port, String jndiName) {
    
    Endpoint ep        = new Endpoint(host,port);
    InitialContext ctx = contexts.get(ep);
    
    if (ctx == null) {
      Properties p = new Properties();
      p.put("org.omg.CORBA.ORBInitialHost",host);
      p.put("org.omg.CORBA.ORBInitialPort",Integer.toString(port));
      p.put("javax.rmi.CORBA.UtilClass","com.sun.corba.ee.impl.javax.rmi.CORBA.Util");
      p.put("javax.rmi.CORBA.StubClass","com.sun.corba.ee.impl.javax.rmi.CORBA.StubDelegateImpl");
      p.put("org.omg.CORBA.ORBSingletonClass","com.sun.corba.se.impl.orb.ORBSingleton");
      p.put("org.omg.CORBA.ORBClass","com.sun.corba.se.impl.orb.ORBImpl");
      p.put("java.naming.factory.initial","com.sun.enterprise.naming.SerialInitContextFactory");
      p.put("java.naming.factory.url.pkgs","com.sun.enterprise.naming");
      p.put("java.naming.factory.state","com.sun.corba.ee.impl.presentation.rmi.JNDIStateFactoryImpl");
      
      try {
        ctx = new InitialContext(p);
      } catch (NamingException e) {
        throw new RuntimeException("Unable to get a reference to the jndi host=" + host + ", port=" + port,e);
      }
      
      contexts.put(ep, ctx);  
    }
    
    try {
      return ctx.lookup(jndiName);
    } catch (NamingException e) {
      throw new RuntimeException("Unable to resolve the name '" + jndiName + "' from the jndi host=" + host + ", port=" + port,e);
    }
    
  }
  
}
