package libraries.ejbUtils.corbaClient;

import java.util.Properties;

import org.omg.CORBA.ORB;
import org.omg.CORBA.Object;
import org.omg.CosNaming.NamingContextExt;
import org.omg.CosNaming.NamingContextExtHelper;

public class CorbaClientService {

  //we should be fine with the EJB restrictions on static variables, because we just create another orb if we're in a cluster.
  //the static is just there to prevent creating an orb on each call
  private static ORB orb;
  
  public synchronized static org.omg.CORBA.Object resolveCorbaObject(String nameToResolve) {

    getOrb();
    
    try {
      Object ns = orb.resolve_initial_references("NameService");

      NamingContextExt nc = NamingContextExtHelper.narrow(ns);
      return nc.resolve_str(nameToResolve);
    }
    catch (Throwable t) {
      throw new RuntimeException("Failed to resolve the corba name " + nameToResolve);
    }
  }
  
  public synchronized static ORB getOrb() {
    if (orb == null) {

      Properties orbProps = new Properties();

      String jacorbHome = System.getProperty("jacorb.home");
      orbProps.put("SVCnameroot", "NameService");
      orbProps.put("java.endorsed.dirs", jacorbHome + "/lib");
      orbProps.put("jacorb.home",jacorbHome);
      orbProps.put("org.omg.CORBA.ORBClass","org.jacorb.orb.ORB"); 
      orbProps.put("org.omg.CORBA.ORBSingletonClass","org.jacorb.orb.ORBSingleton");

      orb = org.omg.CORBA.ORB.init((String[])null, orbProps);
    }
  
    return orb;
  }
  
}
